Index: palm/trunk/SOURCE/advec_particles.f90
===================================================================
--- palm/trunk/SOURCE/advec_particles.f90	(revision 56)
+++ palm/trunk/SOURCE/advec_particles.f90	(revision 57)
@@ -1148,13 +1681,36 @@
 
              ELSE
+
+!
+!--             Restriction of the size of the new timestep: compared to the 
+!--             previous timestep the increase must not exceed 200%
+
+                dt_particle_old = particles(n)%age - particles(n)%age_m
+                IF ( dt_particle > 2.0 * dt_particle_old )  THEN 
+                   dt_particle = 2.0 * dt_particle_old
+                ENDIF
+
 !
 !--             For old particles the SGS components are correlated with the
 !--             values from the previous timestep. Random numbers have also to
 !--             be limited (see above).
+!--             As negative values for the subgrid TKE are not allowed, the
+!--             change of the subgrid TKE with time cannot be smaller than
+!--             -e_int/dt_particle. This value is used as a lower boundary
+!--             value for the change of TKE 
+
+                de_dt_min = - e_int / dt_particle
+
+                de_dt = ( e_int - particles(n)%e_m ) / dt_particle_old
+
+                IF ( de_dt < de_dt_min )  THEN
+                   de_dt = de_dt_min
+                ENDIF
+
                 particles(n)%speed_x_sgs = particles(n)%speed_x_sgs -          &
                        fs_int * c_0 * diss_int * particles(n)%speed_x_sgs *    &
                        dt_particle / ( 4.0 * sgs_wfu_part * e_int ) +          &
-                       ( ( 2.0 * sgs_wfu_part * ( e_int - particles(n)%e_m ) / &
-                         dt_particle ) * particles(n)%speed_x_sgs /            &
+                       ( 2.0 * sgs_wfu_part * de_dt *                          &
+                               particles(n)%speed_x_sgs /                      &
                          ( 2.0 * sgs_wfu_part * e_int ) + de_dx_int            &
                        ) * dt_particle / 2.0                        +          &
@@ -1166,6 +1722,6 @@
                        fs_int * c_0 * diss_int * particles(n)%speed_y_sgs *    &
                        dt_particle / ( 4.0 * sgs_wfv_part * e_int ) +          &
-                       ( ( 2.0 * sgs_wfv_part * ( e_int - particles(n)%e_m ) / &
-                         dt_particle ) * particles(n)%speed_y_sgs /            &
+                       ( 2.0 * sgs_wfv_part * de_dt *                          &
+                               particles(n)%speed_y_sgs /                      &
                          ( 2.0 * sgs_wfv_part * e_int ) + de_dy_int            &
                        ) * dt_particle / 2.0                        +          &
@@ -1177,6 +1733,6 @@
                        fs_int * c_0 * diss_int * particles(n)%speed_z_sgs *    &
                        dt_particle / ( 4.0 * sgs_wfw_part * e_int ) +          &
-                       ( ( 2.0 * sgs_wfw_part * ( e_int - particles(n)%e_m ) / &
-                         dt_particle ) * particles(n)%speed_z_sgs /            &
+                       ( 2.0 * sgs_wfw_part * de_dt *                          &
+                               particles(n)%speed_z_sgs /                      &
                          ( 2.0 * sgs_wfw_part * e_int ) + de_dz_int            &
                        ) * dt_particle / 2.0                        +          &
@@ -1203,4 +1759,11 @@
 
           ENDIF
+
+!
+!--       Remember the old age of the particle ( needed to prevent that a
+!--       particle crosses several PEs during one timestep and for the
+!--       evaluation of the subgrid particle velocity fluctuations )
+          particles(n)%age_m = particles(n)%age
+
 
 !
@@ -1270,4 +1833,689 @@
 
        ENDDO   ! advection loop
+
+
+!
+!--    Particle reflection from walls
+       CALL cpu_log( log_point_s(48), 'advec_part_refle', 'start' )
+
+       DO  n = 1, number_of_particles
+
+!-------------------------------------------------------
+      i2 =  (particles(n)%x + 0.5*dx) * ddx
+      j2 =  (particles(n)%y + 0.5*dy) * ddy
+      k2 =  particles(n)%z / dz + 1
+      
+      particles_x = particles(n)%x
+      particles_y = particles(n)%y
+      particles_z = particles(n)%z
+
+ 
+    IF (k2<=nzb_s_inner(j2,i2).and.nzb_s_inner(j2,i2)/=0) THEN
+
+   old_positions_x = particles(n)%x - particles(n)%speed_x * dt_particle
+   old_positions_y = particles(n)%y - particles(n)%speed_y * dt_particle
+   old_positions_z = particles(n)%z - particles(n)%speed_z * dt_particle
+   i1= (old_positions_x +0.5*dx) * ddx
+   j1 =(old_positions_y +0.5*dy) * ddy
+   k1 = old_positions_z / dz
+    
+
+!-- CASE 1
+
+   IF ( particles(n)%x  >  old_positions_x .and. &
+         particles(n)%y  >  old_positions_y )THEN
+ 
+     
+
+
+     t_index = 1
+   
+     Do i = i1, i2
+     xline = i*dx+0.5*dx
+     
+     t(t_index) =(xline-old_positions_x)/(particles(n)%x-old_positions_x)
+     t_index = t_index + 1
+     ENDDO
+
+     Do j = j1, j2
+     yline = j*dy+0.5*dy
+     
+     t(t_index) =(yline-old_positions_y)/(particles(n)%y-old_positions_y)
+     t_index = t_index + 1
+     ENDDO
+
+     IF ( particles(n)%z < old_positions_z ) THEN
+     Do k = k1, k2 , -1
+     zline = k*dz
+     t(t_index) = (old_positions_z-zline)/(old_positions_z-particles(n)%z)
+     t_index = t_index + 1
+     ENDDO
+     ENDIF
+     t_index_number = t_index-1
+!-- sorting t
+                   inc = 1
+                   jr  = 1
+                   DO WHILE ( inc <= t_index_number )
+                      inc = 3 * inc + 1
+                   ENDDO
+
+                   DO WHILE ( inc > 1 )
+                      inc = inc / 3
+                      DO  ir = inc+1, t_index_number
+                         tmp_t = t(ir)
+                         jr = ir
+                         
+                         DO WHILE ( t(jr-inc) > tmp_t )
+                            t(jr) = t(jr-inc)
+                            jr = jr - inc
+                            IF ( jr <= inc )  THEN
+                           EXIT
+                            ENDIF
+                         ENDDO
+                        t(jr) = tmp_t
+                       
+             ENDDO
+        ENDDO
+    
+
+   
+   
+    Do t_index = 1, t_index_number
+  
+    positions_x = old_positions_x + t(t_index)*(particles_x - old_positions_x)
+    positions_y = old_positions_y + t(t_index)*(particles_y - old_positions_y)
+    positions_z = old_positions_z + t(t_index)*(particles_z - old_positions_z)
+
+     
+    
+     i3 = (positions_x + 0.5*dx) * ddx   
+     j3 = (positions_y + 0.5*dy) * ddy
+     k3 =  positions_z / dz
+
+     i5 = positions_x * ddx
+     j5 = positions_y * ddy
+     k5 = positions_z / dz
+
+     
+ 
+
+
+    IF (k5 <= nzb_s_inner(j5,i3).and.nzb_s_inner(j5,i3)/=0 ) THEN
+             
+         IF ( positions_z == nzb_s_inner(j5,i3)*dz.and. &
+          k3 == nzb_s_inner(j5,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+          
+           IF ( use_sgs_for_particles )  THEN
+             particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+           ENDIF
+          GOTO 999
+       ENDIF
+    ENDIF
+   
+IF (k5 <= nzb_s_inner(j3,i5).and.nzb_s_inner(j3,i5)/=0 ) THEN
+             
+         IF ( positions_z == nzb_s_inner(j3,i5)*dz.and. &
+          k3 == nzb_s_inner(j3,i5) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+            
+            IF ( use_sgs_for_particles )  THEN
+              particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+            ENDIF
+           
+          GOTO 999
+       ENDIF
+    ENDIF
+  
+     IF (k3 <= nzb_s_inner(j3,i3).and.nzb_s_inner(j3,i3)/=0 ) THEN
+
+       IF ( positions_z == nzb_s_inner(j3,i3)*dz.and. &
+          k3 == nzb_s_inner(j3,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+           
+           IF ( use_sgs_for_particles )  THEN
+          particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+           ENDIF
+           
+          GOTO 999
+       ENDIF
+    
+       IF ( positions_y == j3*dy-0.5*dy .and. &
+         positions_z < nzb_s_inner(j3,i3)*dz) THEN
+              
+          particles(n)%y = 2*positions_y - particles_y
+          particles(n)%speed_y = - particles(n)%speed_y
+          
+          IF ( use_sgs_for_particles )  THEN
+            particles(n)%speed_y_sgs = - particles(n)%speed_y_sgs
+          ENDIF
+   
+          GOTO 999
+       ENDIF
+
+  
+       IF ( positions_x == i3*dx-0.5*dx.and. &
+            positions_z < nzb_s_inner(j3,i3)*dz ) THEN
+              
+          particles(n)%x = 2*positions_x - particles_x
+          particles(n)%speed_x = - particles(n)%speed_x
+       
+        IF ( use_sgs_for_particles )  THEN 
+          particles(n)%speed_x_sgs = - particles(n)%speed_x_sgs
+          GOTO 999
+        ENDIF  
+        
+        ENDIF
+     
+     ENDIF 
+    ENDDO
+   ENDIF
+    
+!-- CASE 2
+  
+     IF ( particles(n)%x  >  old_positions_x .and. &
+         particles(n)%y  <  old_positions_y )THEN
+ 
+
+     t_index = 1
+   
+     Do i = i1, i2
+     xline = i*dx+0.5*dx
+     
+     t(t_index) =(xline-old_positions_x)/(particles(n)%x-old_positions_x)
+     t_index = t_index + 1
+     ENDDO
+
+     Do j = j1, j2,-1
+     yline = j*dy-0.5*dy
+     
+     t(t_index) =(old_positions_y-yline)/(old_positions_y-particles(n)%y)
+     t_index = t_index + 1
+     ENDDO
+
+     IF ( particles(n)%z < old_positions_z ) THEN
+     Do k = k1, k2 , -1
+     zline = k*dz
+     t(t_index) = (old_positions_z-zline)/(old_positions_z-particles(n)%z)
+     t_index = t_index + 1
+     ENDDO
+     ENDIF
+     t_index_number = t_index-1
+
+!-- sorting t
+                   inc = 1
+                   jr  = 1
+                   DO WHILE ( inc <= t_index_number )
+                      inc = 3 * inc + 1
+                   ENDDO
+
+                   DO WHILE ( inc > 1 )
+                      inc = inc / 3
+                      DO  ir = inc+1, t_index_number
+                         tmp_t = t(ir)
+                         jr = ir
+                         
+                         DO WHILE ( t(jr-inc) > tmp_t )
+                            t(jr) = t(jr-inc)
+                            jr = jr - inc
+                            IF ( jr <= inc )  THEN
+                           EXIT
+                            ENDIF
+                         ENDDO
+                        t(jr) = tmp_t
+                       
+             ENDDO
+        ENDDO
+
+     
+  
+     
+    
+   
+    Do t_index = 1, t_index_number
+  
+    positions_x = old_positions_x + t(t_index)*(particles_x - old_positions_x)
+    positions_y = old_positions_y + t(t_index)*(particles_y - old_positions_y)
+    positions_z = old_positions_z + t(t_index)*(particles_z - old_positions_z)
+
+     
+    
+     i3 = (positions_x + 0.5*dx) * ddx   
+     j3 = (positions_y + 0.5*dy) * ddy
+     k3 =  positions_z / dz
+
+     i5 = positions_x * ddx
+     j5 = positions_y * ddy
+     k5 = positions_z / dz
+    
+
+ 
+    IF (k5 <= nzb_s_inner(j3,i5).and.nzb_s_inner(j3,i5)/=0 ) THEN
+             
+         IF ( positions_z == nzb_s_inner(j3,i5)*dz.and. &
+          k3 == nzb_s_inner(j3,i5) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+           
+           IF ( use_sgs_for_particles )  THEN
+            particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+           ENDIF
+       
+          GOTO 999
+       ENDIF
+    ENDIF
+     
+     IF (k3 <= nzb_s_inner(j3,i3).and.nzb_s_inner(j3,i3)/=0 ) THEN
+
+       IF ( positions_z == nzb_s_inner(j3,i3)*dz.and. &
+          k3 == nzb_s_inner(j3,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+          
+         IF ( use_sgs_for_particles )  THEN
+          particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+         ENDIF 
+         
+         GOTO 999
+       ENDIF
+  
+        
+       IF ( positions_x == i3*dx-0.5*dx.and.&
+       positions_z < nzb_s_inner(j3,i3)*dz ) THEN
+              
+          particles(n)%x = 2*positions_x - particles_x
+          particles(n)%speed_x = - particles(n)%speed_x
+          
+          IF ( use_sgs_for_particles )  THEN
+           particles(n)%speed_x_sgs = - particles(n)%speed_x_sgs
+          ENDIF
+          
+          GOTO 999
+       ENDIF
+     
+     ENDIF
+
+     
+     IF (k5 <= nzb_s_inner(j5,i3).and.nzb_s_inner(j5,i3)/=0 ) THEN
+
+       IF ( positions_z == nzb_s_inner(j5,i3)*dz.and. &
+          k3 == nzb_s_inner(j5,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+           IF ( use_sgs_for_particles )  THEN
+            particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+           ENDIF
+
+          GOTO 999
+       ENDIF
+  
+       IF ( positions_y == j5 * dy + 0.5*dy.and.&
+        positions_z < nzb_s_inner(j5,i3)*dz ) THEN
+      
+          particles(n)%y = 2*positions_y - particles_y
+          particles(n)%speed_y = - particles(n)%speed_y
+           
+          IF ( use_sgs_for_particles )  THEN
+            particles(n)%speed_y_sgs = - particles(n)%speed_y_sgs
+          ENDIF
+          GOTO 999
+       ENDIF
+
+     ENDIF 
+    ENDDO
+   ENDIF
+
+
+!-- CASE 3
+
+
+
+        IF ( particles(n)%x < old_positions_x .and. &
+         particles(n)%y > old_positions_y )THEN
+ 
+
+     t_index = 1
+   
+     Do i = i1, i2,-1
+     xline = i*dx-0.5*dx
+     
+     t(t_index) =(old_positions_x-xline)/(old_positions_x-particles(n)%x)
+     t_index = t_index + 1
+     ENDDO
+
+     Do j = j1, j2
+     yline = j*dy+0.5*dy
+     
+     t(t_index) =(yline-old_positions_y)/(particles(n)%y-old_positions_y)
+     t_index = t_index + 1
+     ENDDO
+     
+     IF ( particles(n)%z < old_positions_z ) THEN
+     Do k = k1, k2 , -1
+     zline = k*dz
+     t(t_index) = (old_positions_z-zline)/(old_positions_z-particles(n)%z)
+     t_index = t_index + 1
+     ENDDO
+     ENDIF 
+    
+     t_index_number = t_index-1
+
+!-- sorting t
+                   inc = 1
+                   jr  = 1
+                   DO WHILE ( inc <= t_index_number )
+                      inc = 3 * inc + 1
+                   ENDDO
+
+                   DO WHILE ( inc > 1 )
+                      inc = inc / 3
+                      DO  ir = inc+1, t_index_number
+                         tmp_t = t(ir)
+                         jr = ir
+                         
+                         DO WHILE ( t(jr-inc) > tmp_t )
+                            t(jr) = t(jr-inc)
+                            jr = jr - inc
+                            IF ( jr <= inc )  THEN
+                           EXIT
+                            ENDIF
+                         ENDDO
+                        t(jr) = tmp_t
+                       
+             ENDDO
+        ENDDO
+
+    
+   
+    Do t_index = 1, t_index_number
+  
+    positions_x = old_positions_x + t(t_index)*(particles_x - old_positions_x)
+    positions_y = old_positions_y + t(t_index)*(particles_y - old_positions_y)
+    positions_z = old_positions_z + t(t_index)*(particles_z - old_positions_z)
+
+     
+    
+     i3 = (positions_x + 0.5*dx) * ddx   
+     j3 = (positions_y + 0.5*dy) * ddy
+     k3 =  positions_z / dz
+
+     i5 = positions_x * ddx
+     j5 = positions_y * ddy
+     k5 = positions_z / dz
+
+
+
+     IF (k5 <= nzb_s_inner(j5,i3).and.nzb_s_inner(j5,i3)/=0 ) THEN
+             
+         IF ( positions_z == nzb_s_inner(j5,i3)*dz.and. &
+          k3 == nzb_s_inner(j5,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+         
+         IF ( use_sgs_for_particles )  THEN  
+          particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+         ENDIF
+
+          GOTO 999
+       ENDIF
+    ENDIF
+     
+
+
+      IF (k3 <= nzb_s_inner(j3,i3).and.nzb_s_inner(j3,i3)/=0 ) THEN
+
+       
+      IF ( positions_z == nzb_s_inner(j3,i3)*dz.and. &
+          k3 == nzb_s_inner(j3,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+          
+         IF ( use_sgs_for_particles )  THEN
+          particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+         ENDIF
+
+          GOTO 999
+       ENDIF
+
+          IF ( positions_y == j3*dy-0.5*dy .and. &
+            positions_z < nzb_s_inner(j3,i3)*dz) THEN
+              
+          particles(n)%y = 2*positions_y - particles_y
+          particles(n)%speed_y = - particles(n)%speed_y
+          
+           IF ( use_sgs_for_particles )  THEN
+              particles(n)%speed_y_sgs = - particles(n)%speed_y_sgs
+           ENDIF
+
+          GOTO 999
+       ENDIF  
+
+     ENDIF
+      
+        
+     IF (k5 <= nzb_s_inner(j3,i5).and.nzb_s_inner(j3,i5)/=0 ) THEN
+
+       IF ( positions_z == nzb_s_inner(j3,i5)*dz.and. &
+          k3 == nzb_s_inner(j3,i5) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+          
+         IF ( use_sgs_for_particles )  THEN
+          particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+         ENDIF 
+
+
+          GOTO 999
+       ENDIF
+  
+       IF ( positions_x == i5 * dx + 0.5*dx .and. &
+               positions_z < nzb_s_inner(j3,i5)*dz ) THEN
+      
+          particles(n)%x= 2*positions_x - particles_x
+          particles(n)%speed_x = - particles(n)%speed_x
+          
+         IF ( use_sgs_for_particles )  THEN
+           particles(n)%speed_x_sgs = - particles(n)%speed_x_sgs
+         ENDIF  
+        
+          GOTO 999
+       ENDIF
+
+     ENDIF 
+    ENDDO
+   ENDIF
+
+
+!-- CASE 4
+     
+
+       IF ( particles(n)%x < old_positions_x .and. &
+         particles(n)%y  < old_positions_y )THEN
+ 
+
+     t_index = 1
+   
+     Do i = i1, i2,-1
+     xline = i*dx-0.5*dx
+     
+     t(t_index) =(old_positions_x-xline)/(old_positions_x-particles(n)%x)
+     t_index = t_index + 1
+     
+     
+     
+     ENDDO
+
+     Do j = j1, j2,-1
+     yline = j*dy-0.5*dy
+     
+     t(t_index) =(old_positions_y-yline)/(old_positions_y-particles(n)%y)
+     t_index = t_index + 1
+     
+     
+     ENDDO
+
+     IF ( particles(n)%z < old_positions_z ) THEN
+     Do k = k1, k2 , -1
+     zline = k*dz
+     t(t_index) = (old_positions_z-zline)/(old_positions_z-particles(n)%z)
+     t_index = t_index + 1
+     
+
+     ENDDO
+     ENDIF
+
+     t_index_number = t_index-1
+
+!-- sorting t
+                   inc = 1
+                   jr  = 1
+                   DO WHILE ( inc <= t_index_number )
+                      inc = 3 * inc + 1
+                   ENDDO
+
+                   DO WHILE ( inc > 1 )
+                      inc = inc / 3
+                      DO  ir = inc+1, t_index_number
+                         tmp_t = t(ir)
+                         jr = ir
+                         
+                         DO WHILE ( t(jr-inc) > tmp_t )
+                            t(jr) = t(jr-inc)
+                            jr = jr - inc
+                            IF ( jr <= inc )  THEN
+                           EXIT
+                            ENDIF
+                         ENDDO
+                        t(jr) = tmp_t
+                       
+             ENDDO
+        ENDDO
+    
+    
+    Do t_index = 1, t_index_number
+  
+    positions_x = old_positions_x + t(t_index)*(particles_x - old_positions_x)
+    positions_y = old_positions_y + t(t_index)*(particles_y - old_positions_y)
+    positions_z = old_positions_z + t(t_index)*(particles_z - old_positions_z)
+
+     
+    
+     i3 = (positions_x + 0.5*dx) * ddx   
+     j3 = (positions_y + 0.5*dy) * ddy
+     k3 =  positions_z / dz
+
+     i5 = positions_x * ddx
+     j5 = positions_y * ddy
+     k5 = positions_z / dz
+
+
+
+
+     IF (k3 <= nzb_s_inner(j3,i3).and.nzb_s_inner(j3,i3)/=0 ) THEN
+
+       IF ( positions_z == nzb_s_inner(j3,i3)*dz.and. &
+          k3 == nzb_s_inner(j3,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+         
+          IF ( use_sgs_for_particles )  THEN
+           particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+          ENDIF 
+         
+
+          GOTO 999
+       ENDIF
+     ENDIF
+           
+        
+     IF (k5 <= nzb_s_inner(j3,i5).and.nzb_s_inner(j3,i5)/=0 ) THEN
+
+       IF ( positions_z == nzb_s_inner(j3,i5)*dz.and. &
+          k3 == nzb_s_inner(j3,i5) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+         
+         IF ( use_sgs_for_particles )  THEN 
+          particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+         ENDIF  
+        
+          GOTO 999
+       ENDIF
+  
+       IF ( positions_x == i5 * dx + 0.5*dx .and. nzb_s_inner(j3,i5)/=0.and.&
+                 positions_z < nzb_s_inner(j3,i5)*dz) THEN
+      
+          particles(n)%x= 2*positions_x - particles_x
+          particles(n)%speed_x = - particles(n)%speed_x
+         
+         IF ( use_sgs_for_particles )  THEN  
+           particles(n)%speed_x_sgs = - particles(n)%speed_x_sgs
+         ENDIF 
+          GOTO 999
+       ENDIF
+      
+    ENDIF
+    
+     IF (k5 <= nzb_s_inner(j5,i3).and.nzb_s_inner(j5,i3)/=0) THEN
+       
+
+       IF ( positions_z == nzb_s_inner(j5,i3)*dz.and. &
+          k5 == nzb_s_inner(j5,i3) ) THEN
+      
+          particles(n)%z = 2*positions_z - particles_z
+          particles(n)%speed_z = - particles(n)%speed_z
+          
+          IF ( use_sgs_for_particles )  THEN 
+           particles(n)%speed_z_sgs = - particles(n)%speed_z_sgs
+          ENDIF
+          
+          GOTO 999
+       ENDIF
+
+          IF ( positions_y == j5 * dy + 0.5*dy .and. nzb_s_inner(j5,i3)/=0.and.&
+                    positions_z < nzb_s_inner(j5,i3)*dz ) THEN
+      
+          particles(n)%y= 2*positions_y - particles_y
+          particles(n)%speed_y = - particles(n)%speed_y
+          
+         IF ( use_sgs_for_particles )  THEN
+           particles(n)%speed_y_sgs = - particles(n)%speed_y_sgs
+         ENDIF  
+
+          GOTO 999
+       ENDIF
+
+
+      ENDIF 
+    ENDDO
+   ENDIF
+
+     999 CONTINUE
+    
+   ENDIF
+
+!---------------------------------------------------
+
+       ENDDO   ! particle reflection from walls
+
+       CALL cpu_log( log_point_s(48), 'advec_part_refle', 'stop' )
+
+!
+!--    User-defined actions after the evaluation of the new particle position
+       CALL user_advec_particles
 
 !
@@ -1500,8 +2748,8 @@
           trlp = particle_type( 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
                                 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
-                                0, 0, 0, 0 )
+                                0.0, 0, 0, 0, 0 )
           trrp = particle_type( 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
                                 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
-                                0, 0, 0, 0 )
+                                0.0, 0, 0, 0, 0 )
 
           IF ( use_particle_tails )  THEN
@@ -1933,8 +3181,8 @@
           trsp = particle_type( 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
                                 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
-                                0, 0, 0, 0 )
+                                0.0, 0, 0, 0, 0 )
           trnp = particle_type( 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
                                 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
-                                0, 0, 0, 0 )
+                                0.0, 0, 0, 0, 0 )
 
           IF ( use_particle_tails )  THEN
@@ -2460,4 +3708,20 @@
 
           nn = particles(n)%tail_id
+
+!
+!--       Stop if particles have moved further than the length of one 
+!--       PE subdomain
+          IF ( ABS(particles(n)%speed_x) >                                  & 
+               ((nxr-nxl+2)*dx)/(particles(n)%age-particles(n)%age_m)  .OR. &
+               ABS(particles(n)%speed_y) >                                  &
+               ((nyn-nys+2)*dy)/(particles(n)%age-particles(n)%age_m) )  THEN
+
+             PRINT*, '+++ advec_particles: particle too fast.  n = ', n
+#if defined( __parallel )
+             CALL MPI_ABORT( comm2d, 9999, ierr )
+#else
+             CALL local_stop
+#endif
+          ENDIF
 
           IF ( particles(n)%age > particle_maximum_age  .AND.  &
Index: palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- palm/trunk/SOURCE/buoyancy.f90	(revision 56)
+++ palm/trunk/SOURCE/buoyancy.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Reference temperature pt_reference can be used.
 !
 ! Former revisions:
@@ -59,14 +59,27 @@
 !
 !--       Normal case: horizontal surface
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt-1
-                    tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                    &
+          IF ( use_pt_reference )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                 &
+                        ( theta(k,j,i)   - hom(k,1,pr,0)   ) / pt_reference + &
+                        ( theta(k+1,j,i) - hom(k+1,1,pr,0) ) / pt_reference   &
+                                                            )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                  &
                         ( theta(k,j,i)   - hom(k,1,pr,0)   ) / hom(k,1,pr,0) + &
                         ( theta(k+1,j,i) - hom(k+1,1,pr,0) ) / hom(k+1,1,pr,0) &
-                                                          )
-                ENDDO
-             ENDDO
-          ENDDO
+                                                            )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
 
        ELSE
@@ -136,10 +149,19 @@
 !
 !--       Normal case: horizontal surface
-          DO  k = nzb_s_inner(j,i)+1, nzt-1
-              tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                          &
+          IF ( use_pt_reference )  THEN
+             DO  k = nzb_s_inner(j,i)+1, nzt-1
+                 tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                      &
+                        ( theta(k,j,i)   - hom(k,1,pr,0)   ) / pt_reference + &
+                        ( theta(k+1,j,i) - hom(k+1,1,pr,0) ) / pt_reference   &
+                                                       )
+             ENDDO
+          ELSE
+             DO  k = nzb_s_inner(j,i)+1, nzt-1
+                 tend(k,j,i) = tend(k,j,i) + g * 0.5 * (                       &
                         ( theta(k,j,i)   - hom(k,1,pr,0)   ) / hom(k,1,pr,0) + &
                         ( theta(k+1,j,i) - hom(k+1,1,pr,0) ) / hom(k+1,1,pr,0) &
-                                                    )
-          ENDDO
+                                                       )
+             ENDDO
+          ENDIF
 
        ELSE
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 56)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 57)
@@ -5,5 +5,6 @@
 ! -----------------
 ! "by_user" allowed as initializing action, -data_output_ts,
-! leapfrog with non-flat topography not allowed any more
+! leapfrog with non-flat topography not allowed any more, pt_reference is
+! checked
 !
 ! Former revisions:
@@ -574,4 +575,8 @@
 
 !
+!-- Reference temperature to be used in buoyancy terms
+    IF ( pt_reference /= 9999999.9 )  use_pt_reference = .TRUE.
+
+!
 !-- In case of a given slope, compute the relevant quantities
     IF ( alpha_surface /= 0.0 )  THEN
Index: palm/trunk/SOURCE/diffusion_e.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_e.f90	(revision 56)
+++ palm/trunk/SOURCE/diffusion_e.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Reference temperature pt_reference can be used in buoyancy term
 !
 ! Former revisions:
@@ -82,6 +82,11 @@
                 dpt_dz = ( theta(k+1,j,i) - theta(k-1,j,i) ) * dd2zu(k)
                 IF ( dpt_dz > 0.0 ) THEN
-                   l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                                     SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+                   IF ( use_pt_reference )  THEN
+                      l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+                                        SQRT( g / pt_reference * dpt_dz ) + 1E-5
+                   ELSE
+                      l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+                                        SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+                   ENDIF
                 ELSE
                    l_stable = l_grid(k)
@@ -195,6 +200,11 @@
           dpt_dz = ( theta(k+1,j,i) - theta(k-1,j,i) ) * dd2zu(k)
           IF ( dpt_dz > 0.0 ) THEN
-             l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                               SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+             IF ( use_pt_reference )  THEN
+                l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+                                  SQRT( g / pt_reference * dpt_dz ) + 1E-5
+             ELSE
+                l_stable = 0.76 * SQRT( e(k,j,i) ) / &
+                                  SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+             ENDIF
           ELSE
              l_stable = l_grid(k)
